package Liszt

class ConfigMap extends scala.collection.immutable.Map[String,Any] with scala.collection.immutable.MapLike[String,Any,ConfigMap] {
	private var config = Map.empty[String,Any]
	
	val _ = {
		val file = new java.io.File("liszt.cfg")
		if(file.exists()) {
			loadFromFile("liszt.cfg")
		}
	}
	
	def loadFromFile(config_file : String) {
		config = scala.util.parsing.json.JSON.parseFull(scala.io.Source.fromFile(new java.io.File(config_file)).mkString).get.asInstanceOf[Map[String,Any]]
	}
	override def get(key:String) : Option[Any] = config.get(key)
	override def iterator : Iterator[ ( String, Any) ] = config.iterator
	override def +[B1 >: Any](kv: (String,B1)) : Map[String,B1] = config + kv
	override def -(key : String) : ConfigMap = throw new Exception("unimplemented")
	override def empty = throw new Exception("unimplemented")
	override def toString = "Config { %s }".format(config)
}

object Config extends ConfigMap
