package Liszt
class GraphViz {
	private var edges : List[(Int,Int,String)] = List()
	private var objs : List[(AnyRef,Int)] = List()
	def quote(s : String) : String = {
		val q = List("<",">","{","}")
		val r = q.foldLeft(s.toString) { (str:String,q:String) => str.replace(q,"\\"+q) }
		r.replace("\n","\\l")
	}
	def apply(edge : (AnyRef,AnyRef), color : String = "black") : this.type = {
		val (a,b) = edge
		def getID(e : AnyRef) : Int = {
			val obj = objs find { case (ee,_) =>  ee eq e }
			obj match {
				case Some( (_,i) ) => i
				case None => {
					val i = objs.size
					objs = (e,i) :: objs
					i
				}
			}
		}
		edges = (getID(a),getID(b),color) :: edges
		this
	}
	def draw(extra : Map[AnyRef,AnyRef] = Map.empty, name : String = "graph_viz" ) { //extra is a map from a Node to additional information displayed in the text of the nodes
		val labels = for((o,i) <- objs) yield {
			val lbl = o.toString
			"%d [ label = \"%s\\n(%s)\", shape=\"record\" ];".format(i,quote(lbl.toString), extra.getOrElse(o,"").toString )
		}
		val es = for((a,b,c) <- edges) yield "%d -> %d [ color=\"%s\"];".format(a,b,c)
		val dotstring = "digraph { graph [ ]\n%s\n%s}".format(labels.mkString("\n"),es.mkString("\n"))
		val proc = Runtime.getRuntime().exec("dot -Tpdf -o %s.pdf".format(name))
		val out = new java.io.PrintWriter(proc.getOutputStream())
		out.println(dotstring)
		out.close()
	}
}

object GraphTest {
	def main(arr : Array[String]) {
		val g = new GraphViz
		case class M(a : Int)
		g(M(1) -> M(2))(M(2) -> M(1)).draw()
	}
}