package Liszt

object Language extends LanguageTrait with LisztLib with MetaIntegerTrait

trait LanguageTrait extends MetaIntegerTrait {
	class lisztcode extends StaticAnnotation
	def __ : Nothing = throw new Exception("<stub>")
	
	class Mesh
	class MeshObj
	
	class Vertex extends MeshObj
	class Edge extends MeshObj
	class Face extends MeshObj
	class Cell extends MeshObj
	class Set[A <: MeshObj] {
		def foreach(fn : A => Any) = __
		def filter(fn : A => Boolean) : Set[A] = __
	}
	
	type Label = Int
	object withLabel {
		def unapply[A <: MeshObj](a : A) : Option[(A,Label)] = __
	}
	
	class Field[A <: MeshObj, VT] {
		def apply(a : A) : VT = __
		def update(a : A, v : VT) = __
	}
	object liszt {
		def apply(a : => Any) : Liszt.Trees.Tree = Liszt.Trees.IO.decode(a.toString)
	}
	class Numeric[VT]
	implicit def implicitIntNumeric(a : Int) : Numeric[Int] = __
	implicit def implicitFloatNumeric(a : Float) : Numeric[Float] = __
	implicit def implicitDoubleNumeric(a : Double) : Numeric[Double] = __
	
	class Raised[N <: IntM,VT] {
		//NOTE(zach): These ops are disabled for now until we determine how exactly we want vectors to behave
		def *(vt : Vec[N,VT])(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		def /(vt : Vec[N,VT])(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		
		//TODO(zach): the following two methods should not be called directly, but
		//are defined to get around scala bugs when handling sparse vector slices
		def +(vt : Vec[N,VT])(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		def -(vt : Vec[N,VT])(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
	}
	implicit def implicitRaiseToVec[VT,N <: IntM](a : VT) : Raised[N,VT] = __
	
	class Vec[N <: IntM, VT] {
		type Self = Vec[N,VT]
		def x(implicit f : EnsureSize[_0,N]) : VT = __
		def y(implicit f : EnsureSize[_1,N]) : VT = __
		def z(implicit f : EnsureSize[_2,N]) : VT = __
		def w(implicit f : EnsureSize[_3,N]) : VT = __
		def apply[TT <: IntM](n : TT)(implicit f : EnsureSize[TT,N]) : VT = __
		def update[TT <: IntM](n : TT, v : VT)(implicit f : EnsureSize[TT,N]) : Unit = __
		
		def apply(n : Int) : VT = __
		def update(n : Int, v : VT) : Unit = __
		
		def +(vt : Self)(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		def -(vt : Self)(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		def *(vt : Self)(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		def /(vt : Self)(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		//def +(vt : VT)(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		//def -(vt : VT)(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		def *(vt : VT)(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		def /(vt : VT)(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		def unary_- : Vec[N,VT] = __
		def min(vt : Self)(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		def max(vt : Self)(implicit f : VT => Numeric[VT]) : Vec[N,VT] = __
		
		def &[TT <: IntM](rhs : Vec[TT,VT]) : Vec[N#Add[TT],VT] = __
	}
	
	class RaisedToMat[R <: IntM, C <: IntM, VT] {
		def *(vt : Mat[R,C,VT])(implicit f : VT => Numeric[VT]) : Mat[R,C,VT] = __
		def /(vt : Mat[R,C,VT])(implicit f : VT => Numeric[VT]) : Mat[R,C,VT] = __
		
		//TODO(zach): the following two methods should not be called directly, but
		//are defined to get around scala bugs when handling sparse matrix slices
		def +(vt : Mat[R,C,VT])(implicit f : VT => Numeric[VT]) : Mat[R,C,VT] = __
		def -(vt : Mat[R,C,VT])(implicit f : VT => Numeric[VT]) : Mat[R,C,VT] = __
	}
	
	implicit def implicitRaiseToMat[VT,R <: IntM, C <: IntM](a : VT) : RaisedToMat[R,C,VT] = __
	
	class Mat[R <: IntM, C <: IntM, VT] {
		type Self = Mat[R,C,VT]
		def apply[RR <: IntM, CC <: IntM](r : RR, c : CC)(implicit f : EnsureSize[RR,R], ff : EnsureSize[CC,C]) : VT = __
		def update[RR <: IntM, CC <: IntM](r : RR,c : CC, v : VT)(implicit f : EnsureSize[RR,R], f2 : EnsureSize[CC,C]) : Unit = __
		
		def apply(n : Int, m : Int) : VT = __
		def update(n : Int, m : Int, v : VT) : Unit = __
		
		def +(vt : Self)(implicit f : VT => Numeric[VT]) : Mat[R,C,VT] = __
		def -(vt : Self)(implicit f : VT => Numeric[VT]) : Mat[R,C,VT] = __
		def unary_- : Mat[R,C,VT] = __
		
		def *(vt : VT)(implicit f : VT => Numeric[VT]) : Mat[R,C,VT] = __
		def /(vt : VT)(implicit f : VT => Numeric[VT]) : Mat[R,C,VT] = __
		
		def *(v : Vec[C,VT])(implicit f : VT => Numeric[VT]) : Vec[R,VT] = __
		def *[C <: IntM, K <: IntM](v : Mat[C,K,VT])(implicit f : VT => Numeric[VT]) : Mat[R,K,VT] = __
	}
	def row[R <: IntM, C <: IntM, VT](m : Mat[R,C,VT], a : Int) : Vec[C,VT] = __
	def col[R <: IntM, C <: IntM, VT](m : Mat[R,C,VT], a : Int) : Vec[R,VT] = __
	
	object Vec {
		def apply[VT](a : VT) : Vec[_1,VT] = __
		def apply[VT](a : VT, b : VT) : Vec[_2,VT] = __
		def apply[VT](a : VT, b : VT, c : VT) : Vec[_3,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT) : Vec[_4,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT) : Vec[_5,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT) : Vec[_6,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT) : Vec[_7,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT) : Vec[_8,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT) : Vec[_9,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT) : Vec[_10,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT) : Vec[_11,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT) : Vec[_12,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT, m: VT) : Vec[_13,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT, m: VT, n: VT) : Vec[_14,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT, m: VT, n: VT, o: VT) : Vec[_15,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT, m: VT, n: VT, o: VT, p: VT) : Vec[_16,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT, m: VT, n: VT, o: VT, p: VT, q: VT) : Vec[_17,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT, m: VT, n: VT, o: VT, p: VT, q: VT, r: VT) : Vec[_18,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT, m: VT, n: VT, o: VT, p: VT, q: VT, r: VT, s: VT) : Vec[_19,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT, m: VT, n: VT, o: VT, p: VT, q: VT, r: VT, s: VT, t: VT) : Vec[_20,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT, m: VT, n: VT, o: VT, p: VT, q: VT, r: VT, s: VT, t: VT, u: VT) : Vec[_21,VT] = __
		def apply[VT](a : VT, b : VT, c : VT, d : VT, e : VT, f: VT, g: VT, h: VT, i: VT, j: VT, k: VT, l: VT, m: VT, n: VT, o: VT, p: VT, q: VT, r: VT, s: VT, t: VT, u: VT, w: VT) : Vec[_22,VT] = __
	}
	
	object Mat {
		def apply[VT,N <: IntM](a1 : Vec[N,VT]) : Mat[_1,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT]) : Mat[_2,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT]) : Mat[_3,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT]) : Mat[_4,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT]) : Mat[_5,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT]) : Mat[_6,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT]) : Mat[_7,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT]) : Mat[_8,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT]) : Mat[_9,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT]) : Mat[_10,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT]) : Mat[_11,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT]) : Mat[_12,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT],a13 : Vec[N,VT]) : Mat[_13,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT],a13 : Vec[N,VT],a14 : Vec[N,VT]) : Mat[_14,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT],a13 : Vec[N,VT],a14 : Vec[N,VT],a15 : Vec[N,VT]) : Mat[_15,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT],a13 : Vec[N,VT],a14 : Vec[N,VT],a15 : Vec[N,VT],a16 : Vec[N,VT]) : Mat[_16,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT],a13 : Vec[N,VT],a14 : Vec[N,VT],a15 : Vec[N,VT],a16 : Vec[N,VT],a17 : Vec[N,VT]) : Mat[_17,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT],a13 : Vec[N,VT],a14 : Vec[N,VT],a15 : Vec[N,VT],a16 : Vec[N,VT],a17 : Vec[N,VT],a18 : Vec[N,VT]) : Mat[_18,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT],a13 : Vec[N,VT],a14 : Vec[N,VT],a15 : Vec[N,VT],a16 : Vec[N,VT],a17 : Vec[N,VT],a18 : Vec[N,VT],a19 : Vec[N,VT]) : Mat[_19,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT],a13 : Vec[N,VT],a14 : Vec[N,VT],a15 : Vec[N,VT],a16 : Vec[N,VT],a17 : Vec[N,VT],a18 : Vec[N,VT],a19 : Vec[N,VT],a20 : Vec[N,VT]) : Mat[_20,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT],a13 : Vec[N,VT],a14 : Vec[N,VT],a15 : Vec[N,VT],a16 : Vec[N,VT],a17 : Vec[N,VT],a18 : Vec[N,VT],a19 : Vec[N,VT],a20 : Vec[N,VT],a21 : Vec[N,VT]) : Mat[_21,N,VT] = __
		def apply[VT,N <: IntM](a1 : Vec[N,VT],a2 : Vec[N,VT],a3 : Vec[N,VT],a4 : Vec[N,VT],a5 : Vec[N,VT],a6 : Vec[N,VT],a7 : Vec[N,VT],a8 : Vec[N,VT],a9 : Vec[N,VT],a10 : Vec[N,VT],a11 : Vec[N,VT],a12 : Vec[N,VT],a13 : Vec[N,VT],a14 : Vec[N,VT],a15 : Vec[N,VT],a16 : Vec[N,VT],a17 : Vec[N,VT],a18 : Vec[N,VT],a19 : Vec[N,VT],a20 : Vec[N,VT],a21 : Vec[N,VT],a22 : Vec[N,VT]) : Mat[_22,N,VT] = __
	}
	
	class RichComparable[VT] {
		def *<*(b : VT) : VT = __
		def *>*(b : VT) : VT = __
	}
	implicit def implicitRichComparable[VT](v : VT) : RichComparable[VT] = __
	
	def Print(as : Any*) : Unit = __
        def Exit() : Unit = __
	def FieldWithConst[MO <: MeshObj, VT](s : VT) : Field[MO,VT] = __

    def FieldWithLabel[MO <: MeshObj, VT](url : String) : Field[MO,VT] = __

    def BoundarySet[MO <: MeshObj](name : String) : Set[MO] = __
	
	def mesh = new Mesh()
    def vertices(e : Mesh) : Set[Vertex] = __
    def vertices(e : Vertex) : Set[Vertex] = __
    def vertices(e : Edge) : Set[Vertex] = __
    def vertices(e : Face) : Set[Vertex] = __
    def vertices(e : Cell) : Set[Vertex] = __

    
    def cells(e : Mesh) : Set[Cell] = __
    def cells(e : Vertex) : Set[Cell] = __
    def cells(e : Edge) : Set[Cell] = __
    def cells(e : Face) : Set[Cell] = __
    def cells(e : Cell) : Set[Cell] = __

    def edges(e : Mesh) : Set[Edge] = __
    def edges(e : Vertex) : Set[Edge] = __
    def edges(e : Face) : Set[Edge] = __
    def edges(e : Cell) : Set[Edge] = __

    def edgesCCW(e : Face) : Set[Edge] = __
    def edgesCW(e : Face) : Set[Edge] = __

    def faces(e : Mesh) : Set[Face] = __
    def faces(e : Vertex) : Set[Face] = __
    def faces(e : Edge) : Set[Face] = __
    def faces(e : Cell) : Set[Face] = __

    def facesCCW(e : Edge) : Set[Face] = __
    def facesCW(e : Edge) : Set[Face] = __

    def head(e : Edge) : Vertex = __
    def tail(e : Edge) : Vertex = __

    def inside(e : Face) : Cell = __
    def outside(e : Face) : Cell = __

    def flip(e : Edge) : Edge = __
    def flip(e : Face) : Face = __

    def towards(e : Edge,v : Vertex) : Edge = __
    def towards(e : Face,c : Cell) : Face = __
    
    def size[MO <: MeshObj](s : Set[MO]) : Int = __
    def cross[VT](a : Vec[_3,VT],b : Vec[_3,VT]) : Vec[_3,VT] = __
    def dot[N <: IntM, VT](a : Vec[N,VT],b : Vec[N,VT]) : VT = __
    def normalize[N <: IntM, VT](a : Vec[N,VT]) : Vec[N,VT] = __
    def length[N <: IntM, VT](a : Vec[N,VT]) : VT = __
    def outer[R <: IntM, C <: IntM, VT](a : Vec[R,VT], b : Vec[C,VT]) : Mat[R,C,VT] = __
    
    def MATH_PI() : Float = __
    def MIN_FLOAT() : Float = __
    def MAX_FLOAT() : Float = __
    def MIN_DOUBLE() : Double = __
    def MAX_DOUBLE() : Double = __
   // def sin(a : Float) : Float = __
    def sqrt( a: Float) : Float = __ ;
    def fabs( value : Float ) : Float = __ ;
    def MPI_Wtime() : Float = __ ;

    
    def save(filename : String, t : Int) : Unit = __
    def FieldSave[MO <: MeshObj, VT](field : Field[MO,VT], location : String) : Unit = __ 
    
    //label extraction, currently we have labels defined for particular cell-types, and for
    //faces.  We can adopt the same for the dual operations, but they will probably never
    //be used, and we would have to do vertex-type detection to make it correct.
    //In general the labels for vertices are taken from the VTK file format for unstructured grids.
    
    def vertex(c : Cell, l : Label) : Vertex = __
    def edge(c : Cell, l : Label) : Edge = __
    def face(c : Cell, l : Label) : Face = __
    def cell(c : Cell, l : Label) : Cell = __
    
    def vertex(f : Face, l : Label) : Vertex = __
    def edge(f : Face, l : Label) : Edge = __
    def cell(f : Face, l : Label) : Cell = __
    
    def cell(e : Edge, l : Label) : Cell = __
    def face(e : Edge, l : Label) : Face = __
    
    def ID[MO <: MeshObj](m : MO) : Int = __

	class Index
	class RowIndex extends Index
	class ColIndex extends Index
	trait SparseVector {
		type Index <: LanguageTrait.this.Index
		def apply(idx : Index) : Double = __
		def apply[N <: IntM](is : Vec[N,Index]) : Vec[N,Double] = __
		def update(idx : Index, v : Double) {}
		def update[N <: IntM](is : Vec[N,Index], v : Vec[N,Double]) {}
	}
	
	trait SparseMatrix {
		type RowIndex <: LanguageTrait.this.Index
		type ColIndex <: LanguageTrait.this.Index
		def apply(row : RowIndex, col : ColIndex) : Double = __
		def apply[R <: IntM, C <: IntM](rows : Vec[R,RowIndex], cols : Vec[C,ColIndex]) : Mat[R,C,Double] = __
		def update(row : RowIndex, col : ColIndex, v : Double) {}
		def update[R <: IntM, C <: IntM](rows : Vec[R,RowIndex], cols : Vec[C,ColIndex], vs : Mat[R,C,Double]) {}
	}
	
	trait NonZeroes {
		type RowIndex <: LanguageTrait.this.Index
		type ColIndex <: LanguageTrait.this.Index
		def A(row : RowIndex, col : ColIndex) {}
		def A[R <: IntM, C <: IntM](rows : Vec[R,RowIndex], cols : Vec[C,ColIndex]){}
		
		def x(idx : ColIndex) {}
		def x[N <: IntM](is : Vec[N,ColIndex]) {}
		
		def b(idx : RowIndex) {}
		def b[N <: IntM](is : Vec[N,RowIndex]) {}
	}
	
	def AutoIndex : Nothing = throw new Exception("<stub>")
	
	class lisztsolver extends StaticAnnotation
	class lisztexclude extends StaticAnnotation
	
	@lisztexclude
	trait LinearSystem {
		class RowIndex extends LanguageTrait.this.RowIndex
		class ColIndex extends LanguageTrait.this.ColIndex
		
		class X extends SparseVector { type Index = ColIndex }
		class B extends SparseVector { type Index = RowIndex }
		class A extends SparseMatrix { 
			type RowIndex = LinearSystem.this.RowIndex
			type ColIndex = LinearSystem.this.ColIndex
		}
		class NonZeroes extends LanguageTrait.this.NonZeroes {
			type RowIndex = LinearSystem.this.RowIndex
			type ColIndex = LinearSystem.this.ColIndex
		}
		
		def x() : X = __
		def b() : B = __
		def A() : A = __
		
		def solve(A : A, x : X, b : B)
		def nonzeroes( non_zero_constructor : (NonZeroes) => Any) {}
		
		def resid() : Double = 0.0
		def target_resid(d : Double) {}
		def iters() : Int = 1
		def max_iters(i : Int) {}
	}
	
	@lisztsolver
	trait SuperLU extends LinearSystem {
		def solve(A : A, x : X, b : B) {}
	}
	
	@lisztsolver
	trait PetSc extends LinearSystem {
		def solve(A : A, x : X, b : B) {}		
	}
	
	
	type Float3 = Vec[_3,Float]
	
}
