import Liszt.Language._

@lisztcode
object Constants {
	val float3_zero = Vec(0.f,0.f,0.f) ;
	val float3x3_zero = Mat( Vec(0.f,0.f,0.f), Vec(0.f,0.f,0.f), Vec(0.f,0.f,0.f) ) ;
	val iterations = 100 ;
}

@lisztcode
object NavierStokesSolvers {
	val EXPL_EULER = 0 ;
}

@lisztcode
object IC {
/*	
//	Airfoil grid
	val rho_init = 1.4f ;
	val p_init = 1.f ;
	val u_init = Vec(0.5f, 0.0f, 0.0f) ;
	val u_cbc = Vec(0.5f, 0.0f, 0.0f) ;
	val T_init = 1.f ;
	val GAMMA = 1.4f ;
	val mu_ref = 0.0007f ;
	val cfl = 0.25f ;
	val navierStokesSolver = NavierStokesSolvers.EXPL_EULER ;
	val check_interval = 1 ;
	val R_gas = p_init / rho_init / T_init ;
	var first = true ;
	var timeStepMode = 2 ;
	var const_dt = 0.f ;
	val DT = 0.0001f ;
	var dt_minCPU = MIN_FLOAT ;
	var SL_Tref = 273.15f;
	var SL_Sref = 110.4f;
	var Pr = 0.72f;
*/
/*	
//	Capelli grid
	val rho_init = 0.0616f ;
	val p_init = 9.895e+02f ;
	val u_init = Vec(0.0f, 0.0f, 0.0f) ;
	val u_cbc = Vec(697.0f, 0.0f, 0.0f) ;
	val T_init = 55.968f ;
	val GAMMA = 1.4f ;
	val mu_ref = 1.7615e-5f ;
	val cfl = 0.1f ;
	val navierStokesSolver = NavierStokesSolvers.EXPL_EULER ;
	val check_interval = 1 ;
	val R_gas = p_init / rho_init / T_init ;
	var first = true ;
	var timeStepMode = 2 ;
	var const_dt = 0.f ;
	val DT = 0.0001f ;
	var dt_minCPU = MIN_FLOAT ;
	var SL_Tref = 273.15f;
	var SL_Sref = 110.4f;
	var Pr = 0.72f;
*/

//	Hyshot grid
	val rho_init = 1.0f ;
	val p_init = 0.119783502243532f ;
	val u_init = Vec(1.0f, 0.0f, 0.0f) ;
	val u_cbc = Vec(1.0f, 0.0f, 0.0f) ;
	val T_init = 0.119783502243532f ;
	val GAMMA = 1.4f ;
	val mu_ref = 0.0000075f ;
	val cfl = 0.1f ;
	val navierStokesSolver = NavierStokesSolvers.EXPL_EULER ;
	val check_interval = 1 ;
	val R_gas = p_init / rho_init / T_init ;
	var first = true ;
	var timeStepMode = 2 ;
	var const_dt = 0.f ;
	val DT = 0.0001f ;
	var dt_minCPU = MIN_FLOAT ;
	var SL_Tref = 273.15f;
	var SL_Sref = 110.4f;
	var Pr = 0.72f;
}


@lisztcode
object MyJoe {
	def init() {
   	    Print("def init()") ;
		UgpWithCvCompFlow.init() ;
		JoeWithModels.init() ;
	}

	def run() {
	    JoeWithModels.run() ; 
	}
}

@lisztcode
object Joe {
	def main() {
   	    Print("def main()") ;
		MyJoe.init() ;
		MyJoe.run() ;
	}
}

