import Liszt.Language._
import Liszt.MetaInteger._


@lisztcode
object Constants {
	val float3_zero = Vec(0.0,0.0,0.0) ;
	val float5_zero = Vec(0.0,0.0,0.0,0.0,0.0) ;
	val float3x3_zero = Mat( Vec(0.0,0.0,0.0), Vec(0.0,0.0,0.0), Vec(0.0,0.0,0.0) ) ;
	val float5x3_zero = Mat( Vec(0.0,0.0,0.0),  Vec(0.0,0.0,0.0),  Vec(0.0,0.0,0.0), Vec(0.0,0.0,0.0), Vec(0.0,0.0,0.0) ) ;
	val float5x5_zero = Mat( Vec(0.0,0.0,0.0,0.0,0.0),  Vec(0.0,0.0,0.0,0.0,0.0),  Vec(0.0,0.0,0.0,0.0,0.0), Vec(0.0,0.0,0.0,0.0,0.0), Vec(0.0,0.0,0.0,0.0,0.0) ) ;
	val nsteps = 5000 ;
}

@lisztcode
object NavierStokesSolvers {
	val EXPL_EULER = 0 ;
	val IMPL_EULER = 1 ;
}

@lisztcode
object IC {
/*	
//	Airfoil grid
	val rho_init = 1.4 ;
	val p_init = 1.0 ;
	val u_init = Vec(0.5, 0.0, 0.0) ;
	val u_cbc = Vec(0.5, 0.0, 0.0) ;
	val T_init = 1.0 ;
	val GAMMA = 1.4 ;
	val mu_ref = 0.0007 ;
	val cfl = 0.25 ;
	val navierStokesSolver = NavierStokesSolvers.EXPL_EULER ;
	val check_interval = 1 ;
	val R_gas = p_init / rho_init / T_init ;
	var first = true ;
	var timeStepMode = 2 ;
	var const_dt = 0.0 ;
	val DT = 0.0001 ;
	var dt_minCPU = MIN_FLOAT ;
	var SL_Tref = 273.15;
	var SL_Sref = 110.4;
	var Pr = 0.72;
*/
/*	
//	Capelli grid
	val rho_init = 0.0616 ;
	val p_init = 9.895e+02 ;
	val u_init = Vec(0.0, 0.0, 0.0) ;
	val u_cbc = Vec(697.0, 0.0, 0.0) ;
	val T_init = 55.968 ;
	val GAMMA = 1.4 ;
	val mu_ref = 1.7615e-5 ;
	val cfl = 0.1 ;
	val navierStokesSolver = NavierStokesSolvers.EXPL_EULER ;
	val check_interval = 1 ;
	val R_gas = p_init / rho_init / T_init ;
	var first = true ;
	var timeStepMode = 2 ;
	var const_dt = 0.0 ;
	val DT = 0.0001 ;
	var dt_minCPU = MIN_FLOAT ;
	var SL_Tref = 273.15;
	var SL_Sref = 110.4;
	var Pr = 0.72;
*/

//	Hyshot grid
	val rho_init = 1.0 ;
	val p_init = 0.119783502243532 ;
	val u_init = Vec(1.0, 0.0, 0.0) ;
	val u_cbc = Vec(1.0, 0.0, 0.0) ;
	val T_init = 0.119783502243532 ;
	val GAMMA = 1.4 ;
	val mu_ref = 0.0000075 ;
	val cfl = 0.1 ;
	val navierStokesSolver = NavierStokesSolvers.EXPL_EULER ;
	val check_interval = 1 ;
	val R_gas = p_init / rho_init / T_init ;
	var first = true ;
	var timeStepMode = 2 ;
	var const_dt = 0.0 ;
	val DT = 0.0001 ;
	var dt_minCPU = MIN_DOUBLE ;
	var SL_Tref = 273.15;
	var SL_Sref = 110.4;
	var Pr = 0.72;
}

@lisztcode
object Joe {
   def main() {

      Print("Initialize the Joe in Liszt solver") ;
      JoeLisztSolver.init() ;

      Print("Run the Joe in Liszt solver") ;
      JoeLiszt.run() ; 
   }
}