import Liszt.Language._

@lisztcode
object SHTS {
    val rl = 1; val Kq = 0.20f;
    val Position = FieldWithLabel[Vertex,Float3]("position")
    val Temperature = FieldWithConst[Vertex,Float](0.f)
    val Flux = FieldWithConst[Vertex,Float](0.f)
    val Jacobi = FieldWithConst[Vertex,Float](0.f)
    
    def main() {
        //initialize a single point
        for (v <- vertices(mesh)) {
            if (ID(v) == 1) {
                Temperature(v) = 1000.0f;
            } else {
                Temperature(v) = 0.f;
            }
        }
        //run Jacobi iteration
        var i = 0;
        while (i < 1000) {
            for (e <- edges(mesh)) {
                val v1 = head(e)
                val v2 = tail(e)
                val dP = Position(v2) - Position(v1)
                val dT = Temperature(v2) - Temperature(v1)
                val step = 1.0f/(length(dP))
                Flux(v1) += dT*step
                Flux(v2) -= dT*step
                Jacobi(v1) += step
                Jacobi(v2) += step  
            }
            for (p <- vertices(mesh)) {
                Temperature(p) += 0.01f*Flux(p)/Jacobi(p)
            }
            for (p <- vertices(mesh)) { Flux(p) = 0.f; Jacobi(p) = 0.f;}
            i += 1
        }
        for (p <- vertices(mesh)) {
            Print("Temp ", Temperature(p))
        }
    }
}