set min 0
set max 0
set stepsize 1

for {set j $min} {$j <= $max} {set j [expr $j + $stepsize] } {

  set frame $j
  set inputfile [open springs$frame.file r]
  set outputpdb [open file2pdb$frame.pdb w]

  set numbond 0 
  set ind 0
  #puts $outputpdb "CRYST1    0.000    0.000    0.000  90.00  90.00  90.00 P 1           1"

  while { [gets $inputfile line] != -1 } {
    set atomindex1 $ind
    incr ind
    set atomindex2 $ind
    incr ind

    set xpos1 [lindex $line 9]
    set ypos1 [lindex $line 10]
    set zpos1 [lindex $line 11]
    set xpos2 [lindex $line 13]
    set ypos2 [lindex $line 14]
    set zpos2 [lindex $line 15]
    ## Trick: break down index into chain and resid; chain takes the first digit, resid takes the four last digits
    set index1 [lindex $line 1]
    set index2 [lindex $line 2]
    set chain1 [expr int(floor( $index1 / 10000.0))]
    set chain2 [expr int(floor( $index2 / 10000.0))]
    set resid1 [expr $index1 - 10000*int(floor( $index1 / 10000.0))]
    set resid2 [expr $index2 - 10000*int(floor( $index2 / 10000.0))]

    if { [lindex $line 4] == "0" } {
      set atomname1 P
      set atomname2 P
      set resname1 PEP
      set resname2 PEP
    } else {
      set atomname1 G
      set atomname2 G
      set resname1 GLY
      set resname2 GLY
    }

    set occupation1 0.00
    set occupation2 0.00
    set beta1 0.00
    set beta2 0.00
    ## segname is the age of the bond; right now we add 1 to avoid the -1 thing.  will update later.
    set segname1 G0
    set segname2 G0

    puts $outputpdb [format\
        "ATOM  %5d %4s%4s %1s%4d    %8.3f%8.3f%8.3f%6.2f%6.2f      $segname1     "\
        $atomindex1 $atomname1 $resname1 $chain1 $resid1 $xpos1 $ypos1 $zpos1 $occupation1 $beta1 ]
    puts $outputpdb [format\
        "ATOM  %5d %4s%4s %1s%4d    %8.3f%8.3f%8.3f%6.2f%6.2f      $segname2     "\
        $atomindex2 $atomname2 $resname2 $chain2 $resid2 $xpos2 $ypos2 $zpos2 $occupation2 $beta2 ]
    set BondList($numbond) "$atomindex1 $atomindex2"
    incr numbond
    unset segname1
    unset segname2
  }

  close $inputfile

#  if { $j == $max } { 
#    set numatoms $atomindex2 
#  } else {
#    for { set k [expr $atomindex2 + 1] } { $k <= $numatoms } {incr k} { 
#      puts $outputpdb [format\
#      "ATOM  %5d %4s%4s %1s%4d    %8.3f%8.3f%8.3f%6.2f%6.2f           "\
#      $k UNB UNB X 1 0.000 0.000 0.000 0.0 0.0 ]
#    }
#  }
  

  for {set i 0} {$i < $numbond} {incr i} {
    puts $outputpdb [format "CONECT%5d%5d" [lindex $BondList($i) 0] [lindex $BondList($i) 1]]
  }
  puts $outputpdb "END"
  close $outputpdb
}


for {set i $min} {$i <= $max} {set i [expr $i + $stepsize] } {
  mol new file2pdb$i.pdb autobonds off 
  mol modselect 0 top resname GLY 
  mol modstyle 0 top Bonds 0.4 6.0 
  mol modcolor 0 top ColorID 7 

  mol addrep top
  mol modselect 1 top resname PEP 
  mol modstyle 1 top Bonds 0.4 6.0 
  mol modcolor 1 top ColorID 1 

  set LastAdd [expr $i - 1]
  if {$LastAdd > 0} { 
    mol addrep top
    mol modselect 2 top segname G$LastAdd 
    mol modstyle 2 top Bonds 0.4 6.0 
    mol modcolor 2 top ColorID 0 
  }  
  if {$LastAdd > 1} { 
    mol addrep top
    mol modselect 3 top resname GLY and not segname G0 
    mol modstyle 3 top Bonds 0.4 6.0 
    mol modcolor 3 top ColorID 23 
  } 
}

rotate y by 90
color Display Background white
