#include <string>
#include "parse.h"
#include <stdlib.h>

using namespace MeshIO;

int main(int argc, char * argv[]) {
    if (argc < 4) {
        printf("usage: meshconv <mesh.obj> <data.dat> <out.lmesh>\n");
        return -1;
    }

    const char* meshfile = argv[1];
    const char* datafile = argv[2];
    const char* output   = argv[3];

    LisztFileWriter writer;
    CellWallParse cwp;

    cwp.init(&writer,meshfile,datafile,output);
    cwp.parseAll();
    writer.writeHeader();
    writer.close();
    return 1;
}
