import Liszt.Language._


@lisztcode
object Polygons {
  val V = FieldWithConst[Face, Float](0f);
  val Vsub = FieldWithConst[Face, Float](0f);
  val com = FieldWithConst[Face, Vec[_3, Float]](Vec(0f,0f,0f));




  def calculate_COM(f :Face) : Vec[_3, Float] = {
//     Print("Polygons.calculate_COM\n");
    var temp = Vec(0f,0f,0f);
    for(v <- vertices(f)) {
      // Print("  position: ", Springs.position(v));
      temp += Springs.position(v);
    }
    com(f) = temp / size(vertices(f));
    // Print("COM(f): ", temp, temp / size(vertices(f)));
    return temp / size(vertices(f));
  }


  def arrange_Edges(f: Face) = {
  }

  def calculate_V2(f :Face) : Float = {
//    Print("Polygons.calculate_V2\n");
    var comTemp = calculate_COM(f);
    var temp = 0f;
    for(e <- edgesCCW(f)) {
      var delta = (comTemp(_1)-Springs.position(head(e))(_1)) * (Springs.position(tail(e))(_2)-Springs.position(head(e))(_2)) - (comTemp(_2)-Springs.position(head(e))(_2)) * (Springs.position(tail(e))(_1)-Springs.position(head(e))(_1))
      temp += - (  delta  )  *  ( comTemp(_0)  +  Springs.position(head(e))(_0)  +  Springs.position(tail(e))(_0) )/6f;
    }
    V(f) = temp;
    return temp;
  }




  def calculate_V2_subset(f :Face, v :Vertex, dx :Float, dim :Int) : Float = {
//    Print("Polygons.calculate_V2_subset\n");
    var temp = 0f;
    var add = Vec(0f,0f,0f);
    add(dim) = 1;
    var comTemp  = com(f) + add*(dx/size(vertices(f)));

    for(e <- edgesCCW(f)) {
      if(head(e) == v || tail(e) == v) {
        var delta = (comTemp(_1)-Springs.position(head(e))(_1)) * (Springs.position(tail(e))(_2)-Springs.position(head(e))(_2)) - (comTemp(_2)-Springs.position(head(e))(_2)) * (Springs.position(tail(e))(_1)-Springs.position(head(e))(_1));
        temp += -(  delta  )  *  ( comTemp(_0) + Springs.position(head(e))(_0) + Springs.position(tail(e))(_0) )/6;
      }
    }
  //  Print("vsub: ", temp);
    Vsub(f) = temp;
    return temp;
  }




  def calculate_V2_others(f :Face, v :Vertex, dx :Float, dim :Int) : Float = {
//    Print("Polygons.calculate_V2_others");
    var Vother = 0f;
    for(e <- edgesCCW(f)) {
      if(head(e) != v && tail(e) != v) {
        if(dim == 0) {
          Vother += -((com(f)(_1) - Springs.position(head(e))(_1)) * (Springs.position(tail(e))(_2)-Springs.position(head(e))(_2)) - (com(f)(_2)-Springs.position(head(e))(_2)) * (Springs.position(tail(e))(_1)-Springs.position(head(e))(_1))  )*dx/(size(vertices(f))*3);
        } else if(dim == 1) {
          Vother += -(  (Springs.position(tail(e))(_2)-Springs.position(head(e))(_2)) * (Springs.position(head(e))(_0)-Springs.position(tail(e))(_0)+com(f)(_0))  )*dx/(size(vertices(f))*3);
        } else {
          Vother += -(  (Springs.position(head(e))(_1)-Springs.position(tail(e))(_1)) * (Springs.position(head(e))(_0)-Springs.position(tail(e))(_0)+com(f)(_0))  )*dx/(size(vertices(f))*3);
        }
      }
    }
   // Print("Vother: ", Vother);
    return Vother
  }

}


