#!/bin/bash
mkdir -p cluster_output
cp ${LISZT_EXECUTABLE} cluster_output/main
cp ${LISZT_MESH} cluster_output/mesh.lmesh
WORKING_DIR=${PWD}/cluster_output
cd cluster_output
qsub <<EOF
#!/bin/bash
#PBS -N LISZT_${PROJECT_NPROCS}
#PBS -e LISZT_${PROJECT_NPROCS}.err
#PBS -o LISZT_${PROJECT_NPROCS}.out
#PBS -l nodes=${PROJECT_NNODES}:ppn=${PROJECT_PPN}
#PBS -l walltime=04:00:00
#PBS -V


PBS_O_WORKDIR=${WORKING_DIR}

### ---------------------------------------
### BEGINNING OF EXECUTION
### ---------------------------------------

echo The master node of this job is \`hostname\`
echo The working directory is \`echo \$PBS_O_WORKDIR\`
echo This job runs on the following nodes:
echo \`cat \$PBS_NODEFILE\`


### end of information preamble

cd \$PBS_O_WORKDIR
cmd="mpiexec -np ${PROJECT_NPROCS} ./main mesh.lmesh ${PROJECT_REDIRECT_TO_LOG}"
echo "Running MPIEXEC with: $cmd in directory "\`pwd\`
\$cmd >& $\PBS_O_WORKDIR/liszt.log.$\PBS_JOBID
EOF

