#include "MeshIO/LisztFileReader.h"

using namespace MeshIO;
int main(int argc, char ** argv) {
	assert(argc == 2);
	LisztFileReader read;
	read.init(argv[1]);
	const LisztHeader & h = read.header();
	printf("Mesh Info for %s\nnV = %d\nnE = %d\nnF = %d\nnC = %d\nnFE = %d\nnBoundaries = %d\n",
	       argv[1],h.nV,h.nE,h.nF,h.nC,h.nFE,h.nBoundaries);
	BoundarySetEntry * boundaries = read.boundaries();
	for(unsigned int i = 0; i < h.nBoundaries; i++) {
		printf("boundary: name: %s type: %d, start: %d end: %d\n",boundaries[i].name.c_str(),
			   boundaries[i].type,boundaries[i].start,boundaries[i].end);
	}
	read.free(boundaries);
	PositionTable * table = (PositionTable*) read.fieldData(L_VERTEX,L_DOUBLE,3,"position");
	for(unsigned int i = 0; i < h.nV; i++) {
		printf("v = %d position = (%f,%f,%f)\n",i,table->data[i][0],table->data[i][1],table->data[i][2]);
	}
	read.free(table);
	FileFacetEdge * fes = read.facetEdges();
	for(unsigned int i = 0; i < h.nFE; i++) {
		printf("fe = %d, f = %d, e = %d,  (v = %d, c = %d) (v = %d, c = %d)\n",
	    i,fes[i].face,fes[i].edge, fes[i].hf[0].vert, fes[i].hf[0].cell, fes[i].hf[1].vert, fes[i].hf[1].cell);
	}
	return 0;
}
