#ifndef _PARALLEL_LOAD_LOCAL_MEMORY_H
#define _PARALLEL_LOAD_LOCAL_MEMORY_H

#include "Common.h"
#include "FieldAccess.h"
#include "FieldCommunicator.h"

class LocalMemory {
public:
	LocalMemory(size_t n_fields) {
		fields.reset(n_fields);
	}
	void registerType(int field_id, lElementType typ) {
		fields[field_id].field_type = typ;
	}
	void addGhostRead(int field_id, lElementType typ,uint32_t id) {
		fields[field_id].ghost_reads.insert(id);
	}
	void addGhostWrite(int field_id, lElementType typ, uint32_t id) {
		fields[field_id].ghost_writes.insert(id);
	}
	Array<FieldAccess> fields;
};
#endif
