/*
 * CommInfo.h
 *
 *  Created on: Jul 8, 2009
 *      Author: zdevito
 */

#ifndef COMMINFO_H_
#define COMMINFO_H_
#include "liszt_memory.h"
#include <iostream>
#include <vector>
// TODO(mbarrien): Should depend on something else for rank_type
#include "Liszt/ElemTypes.h"
using LisztPrivate::ElemTypes::rank_type;
using LisztPrivate::ElemTypes::id_type;

class CommInfo {
    public:
        struct Message {
            rank_type rank;
            id_type * values;
            size_t size;
            size_t buf_offset;
        };
        CommInfo() : data(NULL) {}
        void init(id_type * d, const int * data_size, const int * data_disp, size_t n) {
            data.reset(new auto_ptr_array_adapter<id_type>(d));
            size_t buf_offset = 0;
            for(size_t i = 0; i < n; i++) {
                if(data_size[i] > 0) {
                    Message m = { i, (*data).get() + data_disp[i], data_size[i],  buf_offset};
                    messages.push_back(m);
                    buf_offset += data_size[i];
                }
            }
            total_size = buf_offset;
        }
        void print() const {
            using namespace std;
            for(size_t i = 0; i < messages.size(); i++) {
                cout << "node " << messages[i].rank << ": ";
                for(size_t j = 0; j < messages[i].size; j++) {
                    cout << messages[i].values[j] << " ";
                }
                cout << endl;
            }
        }
        template<typename GlobalToLocal>
        void translateID(MeshIO::IOElemType typ, GlobalToLocal & func) {
            for(size_t i = 0; i < total_size; i++)
                (*data)[i] = func(typ,(*data)[i]);
        }
        ::std::auto_ptr<auto_ptr_array_adapter<id_type> > data;
        std::vector<Message> messages;
        size_t total_size;
        typedef std::vector<Message>::iterator message_iterator;
};

struct CommPair {
    CommInfo send;
    CommInfo recv;
};
#endif /* COMMINFO_H_ */
