#ifndef GPUMESHDECL_H_
#define GPUMESHDECL_H_

#include "Liszt/ElemTypes.h"
#include "Layout/CRS.h"

namespace LisztGPU {

using namespace ::Layout; //for CRS structures

struct Mesh {
	size_t nvertices;
	size_t nedges;
	size_t nfaces;
	size_t ncells;

	CRS vtov;
	CRS vtoe;
	CRS vtof;
	CRS vtoc;
    
	CRSConst etov;
	CRS etof;
	CRS etoc;
    
	CRS ftov;
	CRS ftoe;
	CRSConst ftoc;
    
	CRS ctov;
	CRS ctoe;
	CRS ctof;
	CRS ctoc;	
};

#define MESH_DIRECTION_BIT 31
#define MESH_DIRECTION_FLAG 0x80000000

struct MeshElement {
	__device__ __host__ MeshElement() {}
	__device__ __host__ MeshElement(const Mesh * m, id_type id_) { init(m, id_); }
	__device__ __host__ void init(const Mesh * m, id_type id_) { mesh = m; id = id_; }
	id_type id;
	const Mesh * mesh;
	__device__ __host__ id_type ID() const {
		return ~MESH_DIRECTION_FLAG & id;
	}
};

#ifdef PROJECT_DEBUG

struct PrintContext {
	char type;
	int count;
	int id;
	PrintContext * next; //circular linked list, with print_context_head pointing to the last element in the list
};

#endif //PROJECT_DEBUG

}
#endif //GPUMESHDECL_H_
