#ifndef KERNELHEADERRUNTIME_H_
#define KERNELHEADERRUNTIME_H_

#include <stdio.h>

#include "Gpu/GPUMath.h"
#include "Gpu/GPUMeshDecl.h"
#include "Gpu/BoundarySet.h"
#include "Gpu/Field.h"
#include "Liszt/ElemTypes.h"
#include "Vector.h"
#include "Matrix.h"
#include "Fields/ReductionOps.h"
#include "MeshIO/LisztFormat.h"
#include "Liszt/Time.h"

using namespace LisztPrivate;

namespace LisztGPU {
	
template<typename MO>
void BoundarySet_init(const char * name, BoundarySet * boundary);

template<typename VT>
void Field_initWithPositions(Field<VertexType, VT > * field);

} //namespace LisztGPU

using namespace LisztGPU;

typedef Mesh ColoringMesh;
#include "Gpu/WorkgroupLauncher.h"

//EXTERN VARIABLE DECLARATIONS
extern Mesh* hMesh;
extern Mesh* dummydMesh;
extern MeshIO::id_t * dummyRenamed_to_global_ids[MeshIO::TYPE_SIZE];

//INTERNAL CPU-GPU FUNCTIONS
void liszt_initialize_globals_gpu();
void liszt_run();

#define COLORING_GET_BOUNDARY(boundary,set_name) cpuGC . boundary .withMesh(&cpu_mesh)

#endif /* KERNELHEADERRUNTIME_H_ */	