#ifndef GPUUTIL_H_
#define GPUUTIL_H_

#define DEVICEALLOC(ptr, size)	if (cudaErrorMemoryAllocation == cudaMalloc(ptr, size)) { fprintf(stderr, "%s::%d: Error allocating memory on GPU", __FILE__, __LINE__); }

inline void check_cuda_error(char * kernel_name) {
	cudaThreadSynchronize();
	cudaError_t err;
	if((err = cudaGetLastError()) != cudaSuccess) {
		printf("error \"%s\" on %s kernel\n",cudaGetErrorString(err), kernel_name);
		exit(1);
	}
}

#endif /* GPUUTIL_H_ */