/*
 * FacetEdge.h
 *
 *  Created on: Aug 11, 2009
 *      Author: zdevito
 */

#ifndef HFMESH_FACETEDGE_H_
#define HFMESH_FACETEDGE_H_


//TODO(zach): this is a duplication of most of the mesh interface's face edge
//it should be folded into that declaration once we fix the FacetEdgeMesh impl

namespace __MESH_IMPL_NAMESPACE_PRIVATE__ {

class FacetEdge {
public:
    FacetEdge();
    FacetEdge(const FacetEdgeData * i);
    FacetEdge(const FacetEdge & fe);
    void reset(const FacetEdgeData * i);
    void reset(const FacetEdge & f);

    id_type ID() const;


    FacetEdge flip() const; //returns the facet edge, return->head() == this->tail(), and return->outside() == this->inside()


    FacetEdge towards(const Cell & c) const; //makes ret->outside() == c
    FacetEdge towards(const Face & f) const; //makes ret->facetedgeCCWAroundEdge().face() == f

    FacetEdge towards(const Edge & e) const;  //makes ret->facetedgeCCWAroundFace().edge() == e
    FacetEdge towards(const Vertex & v) const; //makes ret->head() == v

    bool operator==(const FacetEdge & rhs) const;
    bool operator!=(const FacetEdge & rhs) const;

    Vertex head() const;
    Vertex tail() const;
    Edge  edge() const;
    Face  face() const;
    Cell outside() const;
    Cell inside() const;

    Cell opposite(const Cell & c) const;
    Vertex opposite(const Vertex & v) const;

    Edge edgeThroughVertex() const;
    Edge edgeThroughVertex(const Vertex &) const;

    Face faceThroughCell() const;
    Face faceThroughCell(const Cell &) const;


    Face faceCWAroundEdge() const;
    Face faceCWAroundEdge(const Vertex &) const;

    Face faceCCWAroundEdge() const;
    Face faceCCWAroundEdge(const Vertex &) const;


    Cell cellCWAroundEdge() const;
    Cell cellCWAroundEdge(const Vertex &) const;

    Cell cellCCWAroundEdge() const;
    Cell cellCCWAroundEdge(const Vertex &) const;


    Edge edgeCWAroundFace() const;
    Edge edgeCWAroundFace(const Cell &) const;

    Edge edgeCCWAroundFace() const;
    Edge edgeCCWAroundFace(const Cell &) const;


    Vertex vertexCWAroundFace() const;
    Vertex vertexCWAroundFace(const Cell &) const;

    Vertex vertexCCWAroundFace() const;
    Vertex vertexCCWAroundFace(const Cell &) const;

    FacetEdge facetedgeCWAroundEdge() const;
    FacetEdge facetedgeCWAroundEdge(const Vertex &) const;

    FacetEdge facetedgeCCWAroundEdge() const;
    FacetEdge facetedgeCCWAroundEdge(const Vertex &) const;


    FacetEdge facetedgeCWAroundFace() const;
    FacetEdge facetedgeCWAroundFace(const Cell &) const;

    FacetEdge facetedgeCCWAroundFace() const;
    FacetEdge facetedgeCCWAroundFace(const Cell &) const;

    const FacetEdgeData * internal() const;
private:
    const FacetEdgeData * data;
    friend std::ostream & operator<<(std::ostream & o, const FacetEdgeData & ife);
    friend std::ostream & operator<<(std::ostream & o, const FacetEdge & ife);
};

}
#endif /* FACETEDGE_H_ */
