/*
 * HalfFacetMesh.h
 *
 *  Created on: Mar 8, 2009
 *      Author: zdevito
 */

#ifndef HALFFACETMESH_H_
#define HALFFACETMESH_H_
#include <stdlib.h>
#include <assert.h>
#include <vector>
#include "Liszt/ElemTypes.h"

//Forward Decls
namespace HalfFacetMeshPrivate {

class MeshObjectData;
class VertexData;
class EdgeData;
class FaceData;
class CellData;
class FacetEdgeData;

class MeshObject;
class Vertex;
class Edge;
class Face;
class Cell;
class FacetEdge;

using LisztPrivate::ElemTypes::id_type;

}

//Interface Decls

#define __MESH_IMPL_NAMESPACE_PRIVATE__ HalfFacetMeshPrivate
#include "HalfFacetMesh/Util.h"

#include "HalfFacetMesh/FacetEdge.h"
#include "HalfFacetMesh/FacetEdgeData.h"
#include "HalfFacetMesh/VisitorTags.h"

#include "HalfFacetMesh/MeshObjectData.h"
#include "HalfFacetMesh/VertexData.h"
#include "HalfFacetMesh/EdgeData.h"
#include "HalfFacetMesh/FaceData.h"
#include "HalfFacetMesh/CellData.h"

namespace HalfFacetMeshPrivate {
typedef FacetEdge EdgeInfo;
typedef FacetEdge FaceInfo;
}
#include "MeshInterface/MeshObject.h"
#include "MeshInterface/Vertex.h"
#include "MeshInterface/Edge.h"
#include "MeshInterface/Face.h"
#include "MeshInterface/Cell.h"

#include "HalfFacetMesh/MeshData.h"
#include "MeshInterface/Mesh.h"

#include "ForAll.h"

#undef __MESH_IMPL_NAMESPACE_PRIVATE__

#include<stack>

//Implementation Files
namespace HalfFacetMeshPrivate {
#include "MeshSet.h"
#define SUBCLASS_MESHSET(outer,name,it) \
    class outer::name : public MeshSet<it> { \
    public: \
        name(const it & i) : MeshSet<it>(i) {} \
    };
#define SUBCLASS_MESHSET_WITH_FACTORY(outer,name,it) \
    class outer::name : public MeshSetWithFactory<it> { \
    public: \
        name(const it & i) : MeshSetWithFactory<it>(i) {} \
    };
#define SUBCLASS_SIZEDMESHSET(outer,name,it) \
    class outer::name : public SizedMeshSet<it> { \
    public: \
        name(const it & i,size_t size) : SizedMeshSet<it>(i,size) {} \
    };

#include "HalfFacetMesh/DFSIterBase.h"
#include "HalfFacetMesh/FacetEdge.cpp"
#include "HalfFacetMesh/FacetEdgeData.cpp"
#include "HalfFacetMesh/Edge.cpp"
#include "HalfFacetMesh/Cell.cpp"
#include "HalfFacetMesh/Face.cpp"
#include "HalfFacetMesh/Vertex.cpp"
#include "HalfFacetMesh/Mesh.cpp"

#undef SUBCLASS_MESHSET
#undef SUBCLASS_SIZEDMESHSET
}

//expose the interface classes here
namespace HalfFacetMesh {
    using HalfFacetMeshPrivate::Vertex;
    using HalfFacetMeshPrivate::Edge;
    using HalfFacetMeshPrivate::Face;
    using HalfFacetMeshPrivate::Cell;
    using HalfFacetMeshPrivate::FacetEdge;
    using HalfFacetMeshPrivate::Mesh;
}
#endif /* FACETEDGEMESH_H_ */
