/*
 * VisitorTags.h
 *
 *  Created on: Aug 12, 2009
 *      Author: zdevito
 */

#ifndef HFMESHVISITORTAGS_H_
#define HFMESHVISITORTAGS_H_

namespace HalfFacetMeshPrivate {

class VisitorTags {
public:
    typedef VisitorTag::tag_type tag_type;
    static VisitorTags & instance() {
        static VisitorTags instance_;
        return instance_;
    }
    void add(FacetEdgeData * ife) {
        ifes.push_back(ife);
    }
    tag_type alloc() {
        if(next_tag == 0) {
            overflow();
        }
        return next_tag++;
    }
    bool wasVisited(tag_type iterator_tag, const FacetEdgeData * data) const {
        return data->visit_tag.tag == iterator_tag;
    }
    //visit data with iterator_tag, returns true if the
    //FE was already visited
    bool visit(tag_type iterator_tag, const FacetEdgeData * data) {
        if(iterator_tag == data->visit_tag.tag) {
            return true;
        } else {
            data->visit_tag.tag = iterator_tag;
            return false;
        }
    }
    bool visit(tag_type iterator_tag, const FacetEdge & data) {
        return visit(iterator_tag,data.internal());
    }
private:
    void overflow() {
        //our tag_type overflowith, reset all the tags
        tag_type max = numeric_limits<tag_type>::max();
        for(vector<FacetEdgeData*>::iterator it = ifes.begin(), end = ifes.end();
            it != end;
            it++) {
            (*it)->visit_tag.tag = max;
        }
    }
    VisitorTags() : next_tag(1) {

    }
    tag_type next_tag;
    vector<FacetEdgeData *> ifes; //list of all ifes in use, to reset flags when tag_type overflows
};

}
#endif /* VISITORTAGS_H_ */
