#ifndef ABSTRACTWRITECONTEXT_H_
#define ABSTRACTWRITECONTEXT_H_

#include <vector>

namespace Synchronization {

class AbstractWriteContext {
public:
	virtual int getWorkUnitID() const = 0;
};

class SimpleAbstractWriteContext : public AbstractWriteContext {
public:
	SimpleAbstractWriteContext(int workUnitID) : _workUnitID(workUnitID) { }
	SimpleAbstractWriteContext(std::vector<id_type> & ctx) : _workUnitID(ctx[0]) { }
	virtual int getWorkUnitID() const {
		return _workUnitID;
	}
private:
	int _workUnitID;
};



} /* namespace Synchronization */

#endif /* ABSTRACTWRITECONTEXT_H_ */