#ifndef _PARALLEL_LOAD_LOCAL_MEMORY_H
#define _PARALLEL_LOAD_LOCAL_MEMORY_H

#include "ParallelLoad/Common.h"
#include "ParallelLoad/FieldAccess.h"
#include "ParallelLoad/FieldComms.h"
#include "MPI/FieldInit.h"

class LocalMemory {
public:
	LocalMemory() {}
	void addGhostRead(id_type field_id,ElemType typ,id_type id) {
		field_info[typ][field_id].ghost_reads.insert(id);
	}
	void addGhostWrite(id_type field_id,ElemType typ,id_type id) {
		field_info[typ][field_id].ghost_writes.insert(id);
	}
	typedef __gnu_cxx::hash_map<id_type, FieldComms> field_comm_map_t;
	void buildFieldCommMap(shared_ptr<LocalTopology> local_topology, field_comm_map_t * fcms) {
		::LisztMPIPrivate::FieldInit field_init;
		field_init.init(MPI_COMM_WORLD,local_topology);
		for(size_t typ = 0; typ < ELEM_TYPE_SIZE; typ++) {
			for(field_map_t::iterator it = field_info[typ].begin(),
				end = field_info[typ].end();
				it != end;
				it++) {
				FieldComms comms;
				LOG_LOG("About to Init Comms");
                                field_init.initComms((ElemType)typ,&it->second,&comms);
				fcms[typ][it->first] = comms;
			}
		}
	}
private:
	typedef __gnu_cxx::hash_map<id_type, FieldAccess> field_map_t;
	field_map_t field_info[ELEM_TYPE_SIZE];
};
#endif
