#ifndef _BOUNDARY_SET_WRAPPER
#define _BOUNDARY_SET_WRAPPER

template<typename BSet>
class BoundarySetWrapper {
public:
	void init(const BSet * b, size_t num_threads, size_t thread_id) {
		bset = b;
		Util_getEvenDistribution(size(),num_threads,thread_id,&offset,&sz);
	}
	size_t size() const {
		return bset->size();
	}
	typedef typename BSet::iterator iterator;
	iterator iter() const {
		return bset->iter(offset,sz);
	}
private:
	size_t offset;
	size_t sz;
	const BSet * bset;
};

#endif