/*
 * ScalaCppRuntime.h
 *
 *  Created on: Nov 24, 2009
 *      Author: zd
 */

#ifndef SCALACPPRUNTIME_H_
#define SCALACPPRUNTIME_H_

unsigned long long int __total_messages_recv = 0;
unsigned long long int __total_messages_sent = 0;
unsigned long long int __total_bytes_recv = 0;
unsigned long long int __total_bytes_sent = 0;
unsigned long long int __total_global_reductions = 0;
unsigned long long int __total_global_reduction_bytes = 0;
int __mpi_rank = 0;

#include "CRSMesh/CRSMesh.h"

#include "Vector.h"
#include "Matrix.h"
#include "ForAll.h"

#include "MPI/LisztMPI.h"
#include "PrintContext.h"
#include "Liszt/Time.h"


//TODO(zach): Get mesh objects into namespace 



::LisztMPIPrivate::LisztMPI __liszt;

using ::CRSMesh::Vertex;
using ::CRSMesh::Edge;
using ::CRSMesh::Face;
using ::CRSMesh::Cell;
typedef MeshFacade Mesh;
typedef Mesh mesh_type;
using ::MPIField::Field;
using ::LisztPrivate::MPI::BoundarySet;

typedef ::CRSMesh::Mesh::vertex_set vertex_set;
typedef ::CRSMesh::Mesh::edge_set edge_set;
typedef ::CRSMesh::Mesh::face_set face_set;
typedef ::CRSMesh::Mesh::cell_set cell_set;

#include "ScalaStdLib.h"


namespace System {
	PrintContext print_context;
}

static inline void save(const std::string & name, int t) {
	std::cout << "save not supported" << std::endl;
}

static inline const Mesh * mesh() { return __liszt.mesh(); }
static inline void predescriptor(int argc, char ** argv) {
    __liszt.init(argc,argv);
	MPI_Comm_rank(MPI_COMM_WORLD,&__mpi_rank);
}
static inline void prepare() {
}
static inline void finalize() {
    LOG_LOG("TOTAL_MESSAGES_RECV: %llu",__total_messages_recv);
    LOG_LOG("TOTAL_BYTES_RECV: %llu",__total_bytes_recv);
    
    LOG_LOG("TOTAL_MESSAGES_SENT: %llu",__total_messages_sent);
    LOG_LOG("TOTAL_BYTES_SENT: %llu",__total_bytes_sent);
    
    LOG_LOG("TOTAL_REDUCTIONS: %llu",__total_global_reductions);
    LOG_LOG("TOTAL_REDUCTION_BYTES: %llu",__total_global_reduction_bytes);
    __liszt.finalize();
}
static inline id_type ID_v(const Vertex & v) {
    return __liszt.getGlobalID(v);
}
static inline id_type ID_e(const Edge & e) {
    return __liszt.getGlobalID(e);
}
static inline id_type ID_f(const Face & f) {
    return __liszt.getGlobalID(f);
}
static inline id_type ID_c(const Cell & c) {
    return __liszt.getGlobalID(c);
}

#endif /* SCALACPPRUNTIME_H_ */
