/*
 * ScalaCppRuntime.h
 *
 *  Created on: Nov 24, 2009
 *      Author: zd
 */

#ifndef SCALACPPRUNTIME_H_
#define SCALACPPRUNTIME_H_

#include "CRSMesh/CRSMesh.h"
#include "Vector.h"
#include "ForAll.h"

#include "SingleCore/LisztSingle.h"
#include "Liszt/Time.h"

static int __mpi_rank = 0;

::LisztSinglePrivate::LisztSingle __liszt;
using ::CRSMesh::Vertex;
using ::CRSMesh::Edge;
using ::CRSMesh::Face;
using ::CRSMesh::Cell;
using ::CRSMesh::Mesh;
using ::LisztPrivate::BoundarySet;
using ::SingleField::Field;
typedef Mesh mesh_type;

typedef Mesh::vertex_set vertex_set;
typedef Mesh::edge_set edge_set;
typedef Mesh::face_set face_set;
typedef Mesh::cell_set cell_set;

#include "ScalaStdLib.h"
#include "PrintContext.h"

static inline id_type ID_v(const Vertex & v) {
    return __liszt.getGlobalID(v);
}
static inline id_type ID_e(const Edge & e) {
    return __liszt.getGlobalID(e);
}
static inline id_type ID_f(const Face & f) {
    return __liszt.getGlobalID(f);
}
static inline id_type ID_c(const Cell & c) {
    return __liszt.getGlobalID(c);
}

#include "SingleCore/LinearSystem.h"


static inline const Mesh * mesh() { return __liszt.mesh(); }


namespace System {
	PrintContext print_context;
}
static inline void save(const std::string & name, int t) {
	std::ostringstream ss;
	ss << name << "_" << t << ".vtu";
	__liszt.saveVTKFile(ss.str());
}

static inline void predescriptor(int argc, char ** argv) {
    __liszt.init(argc,argv);
}

static inline void prepare() {

}

static inline void finalize() {
    __liszt.finalize();
}

#endif /* SCALACPPRUNTIME_H_ */
