/*
 * ScalaCppRuntime.h
 *
 *  Created on: Nov 24, 2009
 *      Author: zd
 */

#ifndef SCALACPPRUNTIME_H_
#define SCALACPPRUNTIME_H_

#include "CRSMesh/CRSMesh.h"

#include "Vector.h"
#include "ForAll.h"

#include "SingleCore/LisztSingle.h"

::LisztSinglePrivate::LisztSingle __liszt;
using ::CRSMesh::Vertex;
using ::CRSMesh::Edge;
using ::CRSMesh::Face;
using ::CRSMesh::Cell;
using ::CRSMesh::Mesh;
using ::LisztPrivate::BoundarySet;
using ::SingleField::Field;
typedef Mesh mesh_type;

typedef Mesh::vertex_set vertex_set;
typedef Mesh::edge_set edge_set;
typedef Mesh::face_set face_set;
typedef Mesh::cell_set cell_set;

#include "ScalaStdLib.h"

static inline id_type ID_v(const Vertex & v) {
    return __liszt.getGlobalID(v);
}
static inline id_type ID_e(const Edge & e) {
    return __liszt.getGlobalID(e);
}
static inline id_type ID_f(const Face & f) {
    return __liszt.getGlobalID(f);
}
static inline id_type ID_c(const Cell & c) {
    return __liszt.getGlobalID(c);
}

static inline const Mesh * mesh() { return __liszt.mesh(); }

#include "SingleCore/vectorizer.h"

extern "C" {

::LisztSinglePrivate::LisztSingle * LisztClient_liszt();
void LisztClient_predescriptor(int argc, char ** argv);
void LisztClient_main();
}

#endif /* SCALACPPRUNTIME_H_ */
