#ifndef _FIELD_DISPLAY_DECL
#define _FIELD_DISPLAY_DECL

#include "Liszt/ElemTypes.h"

using namespace LisztPrivate::ElemTypes;
class IObject;

class FieldDisplay {
public:
    virtual ElemType fieldDomain() const = 0;
    std::string fieldDomainString() const {
        switch(fieldDomain()) {
        case VERTEX:
           return "Vertex";
        case EDGE:
           return "Edge";
        case FACE:
           return "Face";
        case CELL:
           return "Cell";
        default:
            return "Unknown";
        }
    }
    virtual std::string fieldRangeString() const = 0;
    virtual std::string name() const = 0;

    virtual ~FieldDisplay() {}

    template<typename MO>
    IObject operator()(const MO & mo) const;
	virtual IObject atID(id_type id) const = 0;
	//save the data, returns identifier, will be sequential
	//i is the address of the field that chagned
	virtual size_t snapshot() = 0;

	virtual void setSnapshot(size_t i) = 0;
	virtual void reset() = 0;
    virtual size_t size() const = 0;
    enum DisplayMode { DISPLAY_CURRENT, DISPLAY_HISTORY };
    virtual void setDisplayMode(DisplayMode dm) = 0;
};

#endif
