#ifndef _LINEAR_SYSTEM_H
#define _LINEAR_SYSTEM_H

#ifdef SPARSE_MATRIX_ENABLED

#include "LinearSystemIndex.h"
#include "LinearSystemSuperLU.h"
//#include "LinearSystemPetSc.h"

#define LINEAR_SYSTEM_INIT(linear_system) do { \
	linear_system##_index.init(mesh()->vertices().size(),mesh()->edges().size(),mesh()->faces().size(),mesh()->cells().size() + 1); \
	LinearSystemIndex::Index parts[2] = {0, linear_system##_index.nRows()}; \
	linear_system.init(linear_system##_index.nRows(),linear_system##_index.nCols(),0,1,parts); \
} while(0); 

#define SPARSE_VECTOR_READ_1(v,idx) v->read(idx)
#define SPARSE_VECTOR_READ_N(v,idx) v->read(idx)

#define SPARSE_VECTOR_WRITE_1(v,idx,op,rhs) v->write<op>(idx,rhs)
#define SPARSE_VECTOR_WRITE_N(v,idx,op,rhs) v->write<op>(idx,rhs)


#define SPARSE_MATRIX_READ_1(v,r,c) v->read(r,c)
#define SPARSE_MATRIX_READ_N(v,r,c) v->read(r,c)

#define SPARSE_MATRIX_WRITE_1(v,r,c,op,rhs) v->write<op>(r,c,rhs)
#define SPARSE_MATRIX_WRITE_N(v,row,col,op,rhs) v->write<op>(row,col,rhs)


#endif //SPARSE_MATRIX_ENABLED

#endif