#ifndef _LINEAR_SYSTEM_INDEX_H
#define _LINEAR_SYSTEM_INDEX_H

#ifdef SPARSE_MATRIX_ENABLED

class LinearSystemIndex {
public:
	typedef uint64_t Index;
	void init(size_t nV_, size_t nE_, size_t nF_, size_t nC_) {
		nV = nV_;
		nE = nE_;
		nF = nF_;
		nC = nC_;
		generated_init();
	}
	virtual void generated_init() = 0;
	size_t nRows() { return numRows; }
	size_t nCols() { return numCols; }
protected:
	size_t getID(const Vertex & v) { return ID_v(v); }
	size_t getID(const Edge & v) { return ID_e(v); }
	size_t getID(const Face & v) { return ID_f(v); }
	size_t getID(const Cell & v) { return ID_c(v); }
	
	void setRowSize(size_t r) { numRows = r; }
	void setColSize(size_t c) { numCols = c; }
	
	size_t localRowOffset() { return 0; }
	size_t localColOffset() { return 0; }
	
	size_t numRows, numCols;
	size_t nV,nE,nF,nC;
};

#endif

#endif