/*
 * Snapshot.h
 *
 *  Created on: Nov 24, 2009
 *      Author: zd
 */

#ifndef SNAPSHOT_H_
#define SNAPSHOT_H_
#include "SingleCore/WatchPoint.h"
struct Snapshot {
	typedef ::std::tr1::shared_ptr<WatchPoint> watch_point_ref;
	Snapshot(watch_point_ref wp, const IObject & ov, const IObject & nv, size_t id, const std::string & f, size_t l)
	: watch_point(wp), old_value(ov), new_value(nv), snap_id(id), filename(f), lineno(l) {
	    if(old_value.getType() == TFIELD_VEC)
	        old_value = IObject(old_value.vecValue());
	    if(new_value.getType() == TFIELD_VEC)
	        new_value = IObject(new_value.vecValue());
	}
	watch_point_ref watch_point;
	IObject old_value;
	IObject new_value;
	size_t snap_id;
	std::string filename;
	size_t lineno;
};
#endif /* SNAPSHOT_H_ */
