#ifndef INTERPRET_H
#define INTERPRET_H

#include <map>
#include <string>
#include "liszt_memory.h"


class IObject;
struct Exp {
	typedef std::map<std::string,IObject> ctx;
	virtual void print() = 0;
	virtual bool isError() { return false; }
	IObject eval() const;
	virtual IObject eval(const ctx & ctx) const = 0;
	virtual ~Exp() {}
};
typedef ::std::tr1::shared_ptr<Exp> ExpRef;

struct Closure {
	Closure(const Exp::ctx c, ExpRef e)
	: context(c), exp(e) {}
	Exp::ctx context;
	ExpRef exp;
};
typedef ::std::tr1::shared_ptr<Closure> ClosureRef;
ExpRef interpret_compile(const std::string &);
#endif