#ifndef _SMALL_SET_H
#define _SMALL_SET_H


#define SMALL_SET_N_INLINED (16)
struct SmallSet {
	SmallSet()
	: size_(0) {}

	bool insert(int e) {
		if(size_ < SMALL_SET_N_INLINED) {
			if(!contains(inlined,inlined + size_,e)) {
				inlined[size_++] = e;
				return true;
			} else return false;
		} else {
			if(!contains(inlined,inlined + SMALL_SET_N_INLINED,e) && !contains(overflow.begin(),overflow.end(),e)) {
				overflow.push_back(e);
				size_++;
				return true;
			} else return false;
		}
	}
	size_t size() { return size_; }
	struct Iterator {
		SmallSet * set;
		size_t i;
		bool next(int * e) {
			if(i < set->size()) {
				if(i < SMALL_SET_N_INLINED)
					*e = set->inlined[i];
				else
					*e = set->overflow[i - SMALL_SET_N_INLINED];
				i++;
				return true;
			} else return false;
		}
	};
	Iterator iterator() {
		Iterator it = { this, 0 };
		return it;
	}
	template<typename T>
	bool contains(T begin, T end, int i) {
		while(begin != end)
			if(*begin++ == i)
				return true;
		return false;
	}
	int inlined[SMALL_SET_N_INLINED];
	std::vector<int> overflow;
	size_t size_;
};

#endif