#include <stdio.h>
#include "MeshIO/LisztFormat.h"
#include "MeshIO/LisztFileReader.h"

using namespace MeshIO;

int main (int argc, char const *argv[]) {
	/* code */
	if (argc != 2) {
		printf("Usage:\n  lmesh_info <input.lmesh>\n");
		exit(1);
	}
	LisztFileReader reader;
	reader.init(argv[1]);
	LisztHeader header = reader.header();

	printf("Mesh file %s\n", argv[1]);
	printf("Header:\n");
	printf("  magic number:         0x%X\n", header.magic_number);
	printf("  number of Vertices:   %d\n", header.nV);
	printf("  number of Edges:      %d\n", header.nE);
	printf("  number of Faces:      %d\n", header.nF);
	printf("  number of Cells:      %d\n", header.nC);
	printf("  number of Face-Edges: %d\n", header.nFE);
	printf("  number of Boundaries: %d\n", header.nBoundaries);
	printf("\n");
	printf("  position table pointer:     0x%lX\n", header.position_table);
	printf("  facet-edge table pointer:   0x%lX\n", header.facet_edge_table);
	printf("  boundary set table pointer: 0x%lX\n", header.boundary_set_table);
	
	return 0;
}
