#include "MeshIO/FluentLex.h"

using namespace MeshIO;
int main(int argc, char ** argv) {
	assert(argc == 2);
	FluentLex lex;
	lex.init(argv[1]);
	while(true) {
		Token t = lex.next();
		switch(t.type) {
			case LPAREN:
				printf("(\n");
				break;
			case RPAREN:
				printf(")\n");
				break;
			case SYMBOL:
				printf("symbol: %s\n",t.data.s);
				break;
			case STRING:
				printf("string: %s\n",t.data.s);
				break;
			case DOUBLE:
				printf("double: %f\n",t.data.d);
				break;
			case INT:
				printf("int: %d\n",t.data.i);
				break;
			case ERROR:
				printf("error: %s\n",t.data.s);
				return 1;
				break;
			case EOF_TYPE:
				return 0;
				break;
            default:
                break;
		}
	}
	return 0;
}
