//
//  ElementInspector.mm
//  lisztvis
//
//  Created by Zach Devito on 11/29/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ElementInspector.h"
#define id Id_hacks
#include "LisztClient.h"
#undef id
#import "Glue.h"
#include <sstream>



enum ElementColumn { EC_NAME, EC_VALUE };
@implementation ElementInspector
-(int)numberOfRowsInTableView:(NSTableView * ) tableView {
	return LisztClient_liszt()->registered_fields[selected_type].size();
}
-(id) tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *) tableColumn row:(int) row {
	switch([[tableColumn identifier] intValue]) {
		case EC_NAME:
			return toNSString(LisztClient_liszt()->registered_fields[selected_type][row]->name());
		case EC_VALUE: {
			std::ostringstream ss;
			ss << LisztClient_liszt()->registered_fields[selected_type][row]->atID(selected_id);
			return toNSString(ss.str());
		}
		default:
			assert(!"unknown identifier");
	}
}
- (void) reloadData {
	std::ostringstream ss;
	switch (selected_type) {
		case VERTEX:
			ss << "Vertex ";
			break;
		case EDGE:
			ss << "Edge ";
			break;
		case FACE:
			ss << "Face ";
			break;
		case CELL:
			ss << "Cell ";
			break;
	}
	ss << selected_id;
	[panel setTitle:toNSString(ss.str())];
	[table reloadData];
}
- (void) setElementSelection: (unsigned int) type withID: (unsigned int) idx atPosition: (NSPoint) point {
	selected_type = type;
	selected_id = idx;
	[self reloadData];
	[panel setFrameTopLeftPoint:point];
	[panel orderFront: self];
}
- (void) awakeFromNib {
	selected_type = VERTEX;
	selected_id = 0;
	[self reloadData];
}
@end
