//
//  FieldTableView.m
//  lisztvis
//
//  Created by Zach Devito on 11/19/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#define id Id_hacks
#include "LisztClient.h"
#undef id

#import "Glue.h"
#import "FieldTableController.h"

static unsigned int findDomain(NSTableView * tv) {
	return [tv tag];
}
enum FColumn { FNAME = 0, FDOMAIN = 1, FRANGE = 2 };
@implementation FieldTableController
-(int)numberOfRowsInTableView:(NSTableView * ) tableView {
	unsigned int et = findDomain(tableView);
	std::cout << "size: " << LisztClient_liszt()->registered_fields[et].size() << std::endl;
	return LisztClient_liszt()->registered_fields[et].size();
}
-(id) tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *) tableColumn row:(int) row {
	unsigned int et = findDomain(tableView);
	switch([[tableColumn identifier] intValue]) {
		case FNAME: 
			return toNSString(LisztClient_liszt()->registered_fields[et][row]->name());
		case FDOMAIN: 
			return toNSString(LisztClient_liszt()->registered_fields[et][row]->fieldDomainString());
		case FRANGE: 
			return toNSString(LisztClient_liszt()->registered_fields[et][row]->fieldRangeString());
		default:
			return @"BUGBUG";
	}
}
- (BOOL)tableView:(NSTableView *)tv writeRowsWithIndexes:(NSIndexSet *)rowIndexes toPasteboard:(NSPasteboard*)pboard {
	unsigned int et = findDomain(tv);
	unsigned int row = [rowIndexes firstIndex];
    [pboard declareTypes:[NSArray arrayWithObject:NSStringPboardType] owner:self];
    [pboard setString:toNSString(LisztClient_liszt()->registered_fields[et][row]->name() + "(id)") forType:NSStringPboardType];
	return YES;
}
- (void) awakeFromNib {
	[face_table registerForDraggedTypes: [NSArray arrayWithObject:@"MyData"] ];
	[edge_table registerForDraggedTypes: [NSArray arrayWithObject:@"MyData"] ];
	[cell_table registerForDraggedTypes: [NSArray arrayWithObject:@"MyData"] ];
	[vert_table registerForDraggedTypes: [NSArray arrayWithObject:@"MyData"] ];
}
@end
