/*
 *  Filter.h
 *  lisztvis
 *
 *  Created by Zach Devito on 11/20/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */
#ifndef _FILTER_H
#define _FILTER_H

#include "interpret.h"
#import "Glue.h"

class Filter {
public:
	void init(ElemType t) { type = t; new (&filterExp) ExpRef(); }
	
	template<typename MO> 
	bool operator()(const MO & mo) const {
		assert(MO::type::value == type);
		return shouldDisplay(mo.ID());
	}
	bool shouldDisplay(id_type idx) {
		if(filterExp) {
			IObject r = getValueForExpWithID(filterExp,idx);
			if(r.isInt())
				return r.intValue();
			else
				return NO;
		} else
			return YES;
	}
	bool setFilterString(const std::string & str) {
		ExpRef exp = interpret_compile(str);
		if(exp->isError()) {
			filterExp.reset();
			return NO;
		} else {
			filterExp = exp;
			return YES;
		}
	}
private:
	ElemType type;
	ExpRef filterExp;
};
#endif