//
//  LegendData.mm
//  lisztvis
//
//  Created by Zach Devito on 11/21/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "LegendData.h"

#import "Glue.h"

NSAttributedString * imageAndText(NSImage * icon, NSString * name){
    NSTextAttachment *attachment;
    attachment = [[[NSTextAttachment alloc] init] autorelease];
    NSCell *cell = [attachment attachmentCell];
    [cell setImage: icon];
	
	NSDictionary * attrDictionary = [NSDictionary dictionaryWithObject: [NSColor whiteColor] forKey: NSForegroundColorAttributeName];
    NSAttributedString *attrname = [[NSAttributedString alloc] initWithString: name attributes: attrDictionary];
	
    NSMutableAttributedString *prettyName;
    prettyName = (id)[NSMutableAttributedString attributedStringWithAttachment:
					  attachment];
    [prettyName appendAttributedString: attrname];
	
    return prettyName;
	
} // prettyName


@implementation LegendData
- (void) awakeFromNib {
	NSLog(@"initimages");
	category_colors.initImages();
	diverging_colors.initImages();
	current_encoding = NULL;
	current_elem_type = VERTEX;
	color_map = &diverging_colors;
	labels = new std::vector<std::string>();
}
-(int)numberOfRowsInTableView:(NSTableView * ) tableView {
	return labels == NULL ? 0 : labels->size();
}
-(id) tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *) tableColumn row:(int) row {
	return imageAndText(color_map->getImages()[row],toNSString((*labels)[row]));
}
- (NSAttributedString*) getText {
	NSString * str = @"Unknown Color";
	switch(current_elem_type) {
		case VERTEX:
			str = @"Vertex Color";
			break;
		case EDGE:
			str = @"Edge Color";
			break;
		case FACE:
			str = @"Face Color";
			break;
		case CELL:
			str = @"Cell Color";
			break;
	}
	NSMutableAttributedString * legend = [[[NSMutableAttributedString alloc] initWithString:str 
																			attributes:[NSDictionary dictionaryWithObject: [NSColor whiteColor] 
																												   forKey: NSForegroundColorAttributeName]] autorelease];
	int sz = [self numberOfRowsInTableView:nil];
	NSAttributedString * newline = [[[NSAttributedString alloc] initWithString:@"\n" attributes:[NSDictionary dictionary]] autorelease];
	for(int i = 0; i < sz; i++) {
		[legend appendAttributedString: newline];
		[legend appendAttributedString: imageAndText(color_map->getImages()[sz - 1 - i],toNSString((*labels)[sz - 1 - i]))];
	}
	return legend;
}
- (BOOL) showLegend {
	return labels != NULL && labels->size() > 1;
}
- (void) reloadData {
    if(current_encoding != NULL) {
        bool isCat;
        current_encoding->createLabels(diverging_colors.size,labels,&isCat);
        color_map = (isCat) ? &category_colors : &diverging_colors;
        [table reloadData];
    }
}
- (void) newEncoding: (Encoding *) e {
	NSLog(@"newencoding");
	current_encoding = e;
	current_elem_type = e->getElemType();
	[self reloadData];
}
@end
