#define ID __ID
#include "LisztClient.h"
#include <dlfcn.h>
#include "QueryBundle.h"

static void * handle = NULL;


typedef ::LisztSinglePrivate::LisztSingle * (*liszt_t)(void);
typedef void (*predescriptor_t)(int,char**);
typedef void (*void_t)(void);
typedef Mesh * (*mesh_t)(void);

static liszt_t liszt_f;
static predescriptor_t predescriptor_f;
static void_t main_f;

static void load_client() {
	if(!handle) {
		const char * library_name = QueryBundle("LisztClient.dylib");
		printf("Library Name is %s\n",library_name);
		handle = dlopen(library_name,RTLD_LAZY);
		if(!handle) {
			printf("error loading client (have you built and installed it in the application bundle?): %s",dlerror());
			exit(1);
		}
		liszt_f = (liszt_t) dlsym(handle,"LisztClient_liszt");
		predescriptor_f = (predescriptor_t) dlsym(handle,"LisztClient_predescriptor");
		main_f = (void_t) dlsym(handle,"LisztClient_main");
		
		assert(liszt_f && predescriptor_f && main_f);
	}
}
::LisztSinglePrivate::LisztSingle * LisztClient_liszt() {
	load_client();
	return liszt_f();
}
Mesh * mesh() {
	static Mesh * internal_mesh = NULL;
	if(!internal_mesh) {
		load_client();
		internal_mesh = const_cast<Mesh *>(LisztClient_liszt()->mesh());
		assert(internal_mesh);
	}
	return internal_mesh;
}
void LisztClient_predescriptor(int argc, char ** argv) {
	load_client();
	return predescriptor_f(argc,argv);
}
void LisztClient_main() {
	load_client();
	main_f();
}