//
//  LisztController.h
//  lisztvis
//
//  Created by Zach Devito on 11/18/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define id Id_hacks
#include "LisztClient.h"
#undef id

#include "Filter.h"
#include "Encoding.h"
#import "LegendData.h"
#import "ElementInspector.h"

extern void RecalcMeshProperties();

enum EncodingTypes { ENC_TEXT, ENC_COLOR, ENC_SIZE,  ENC_VECTOR, ENC_TYPE_SIZE, ENC_POS /*not included in size*/};
@interface LisztController : NSObject {
	bool show_edges;
	bool show_faces;
	bool show_verts;
	bool show_cells;
	IBOutlet id meshView;
	IBOutlet NSPanel * legend;
	IBOutlet LegendData * colorLegend;
    IBOutlet NSWindow * mainWindow;
	IBOutlet ElementInspector * elementInspector;
	IBOutlet NSTableView * snapshot_table;
	IBOutlet NSTableView * vert_field_table;
	IBOutlet NSTableView * edge_field_table;
	IBOutlet NSTableView * face_field_table;
	IBOutlet NSTableView * cell_field_table;
	
	Filter filters[ELEM_TYPE_SIZE];
	Encoding encodings[ELEM_TYPE_SIZE][ENC_TYPE_SIZE];
    Encoding position_encoding;
}

- (bool) displayEdges;
- (bool) displayFaces;
- (bool) displayVerts;
- (bool) displayCells;
- (void) awakeFromNib;
- (IBAction) filterModified: (id) sender;
- (IBAction) encodingModified: (id) sender;
- (IBAction) visibilityModified: (id) sender;
- (IBAction) showLegend: (id) sender;
- (Encoding*) getEncoding: (EncodingTypes) t forType: (ElemType) e; 
- (Filter*) getFilter: (ElemType) type;
- (void)tabView:(NSTabView *)tabView didSelectTabViewItem:(NSTabViewItem *)tabViewItem;
- (IBAction) runSimulation: (id) sender;
- (void) snapshotSelectionChanged;
- (void) setElementSelection: (ElemType) et withID: (id_type) idx atPosition: (NSPoint) point;
@end
