//
//  SnapshotTableController.m
//  lisztvis
//
//  Created by Zach DeVito on 11/24/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "SnapshotTableController.h"

#define id Id_hacks
#include "LisztClient.h"
#undef id
#import "Glue.h"
#include <sstream>

enum SHColumnID { SN_NAME = 0, SN_OLD = 1, SN_NEW = 2, SN_FILE = 3, SN_LINE = 4};

@implementation SnapshotTableController
-(int)numberOfRowsInTableView:(NSTableView * ) tableView {
	return LisztClient_liszt()->snapshots().size(); 
}

-(id) tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *) tableColumn row:(int) row {
	switch([[tableColumn identifier] intValue]) {
		case SN_NAME: 
			return toNSString(LisztClient_liszt()->snapshots()[row]->watch_point->name());
		case SN_OLD: {
			IObject obj = LisztClient_liszt()->snapshots()[row]->old_value;
			std::ostringstream ss;
			ss << obj;
			return toNSString(ss.str());
		}
		case SN_NEW:{
			IObject obj = LisztClient_liszt()->snapshots()[row]->new_value;
			std::ostringstream ss;
			ss << obj;
			return toNSString(ss.str());
		}
		case SN_FILE:
			return toNSString(LisztClient_liszt()->snapshots()[row]->filename);
		case SN_LINE: {
			std::ostringstream ss;
			ss << LisztClient_liszt()->snapshots()[row]->lineno;
			return toNSString(ss.str());
		}
		default:
			return @"BUGBUG";
	}
}
- (void) awakeFromNib {
	[table setDoubleAction:@selector(doubleClicked:)];
	[table setTarget: self];
}
- (IBAction) doubleClicked: (id) sender {
	NSLog(@"DOUBLE CLICKED");
	int row = [table clickedRow];
	if(row >= 0) {
		const std::string & filename = LisztClient_liszt()->snapshots()[row]->filename;
		int lineno = LisztClient_liszt()->snapshots()[row]->lineno;
        NSString * file = [[NSBundle mainBundle] pathForResource:toNSString(filename) ofType: nil];
        NSString * edit_cmd = [[NSBundle mainBundle] pathForResource:@"edit" ofType:nil];
        NSString * textwrangler = [[NSWorkspace sharedWorkspace] absolutePathForAppBundleWithIdentifier: @"com.barebones.textwrangler"];
        assert(edit_cmd != nil);
        if(textwrangler == nil) {
            NSLog(@"no text wrangler");
            NSAlert * alert = [NSAlert alertWithMessageText:@"To view source code you need to install TextWrangler" defaultButton:nil alternateButton:nil otherButton:nil informativeTextWithFormat:@""];
            [alert runModal];
        } else if(file != nil) {
            NSString * arg = [NSString stringWithFormat:@"%@:%d",file,lineno];
            NSLog(arg);
			NSTask * task = [[NSTask alloc] init];
			[task setLaunchPath: edit_cmd];
			[task setArguments:[NSArray arrayWithObject: arg]];
			[task launch];
			[task waitUntilExit];
		} else {
			NSBeep();
		}

	}

}
- (void) tableViewSelectionDidChange: (NSNotification *) notification {
	int row = [[notification object] selectedRow];
	NSLog(@"tableview selection did change %d",row);
	if(row < 0)
		LisztClient_liszt()->setCurrent();
	else
		LisztClient_liszt()->setSnapshot(row);
	[controller snapshotSelectionChanged];
}

@end
