//
//  WatchPointTableController.mm
//  lisztvis
//
//  Created by Zach DeVito on 11/24/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "WatchPointTableController.h"
#define id Id_hacks
#include "LisztClient.h"
#undef id
#import "Glue.h"

enum WPColumnID { WP_NAME = 0, WP_EXPRESSION = 1};

@implementation WatchPointTableController
-(int)numberOfRowsInTableView:(NSTableView * ) tableView {
	return LisztClient_liszt()->watchPoints().size(); 
}

-(id) tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *) tableColumn row:(int) row {
	switch([[tableColumn identifier] intValue]) {
		case WP_NAME: 
			return toNSString(LisztClient_liszt()->watchPoints()[row]->name());
		case WP_EXPRESSION: 
			return toNSString(LisztClient_liszt()->watchPoints()[row]->exp());
		default:
			return @"BUGBUG";
	}
}
- (void)tableView:(NSTableView *)aTableView setObjectValue:(id)anObject forTableColumn:(NSTableColumn *) tableColumn row:(NSInteger)row {
	NSLog(@"setObjectValue: %@",anObject);
	const char * str = [anObject UTF8String];
	
	//hack: if the table is being edited when a row is delete we get a write object for an invalid row
	switch([[tableColumn identifier] intValue]) {
		case WP_NAME: {
			bool nonwhite = false;
			const char * s = str;
			while(*s) if(!isspace(*s++)) nonwhite = true;
			if(nonwhite)
				LisztClient_liszt()->watchPoints()[row]->setName(str);
		} break;
		case WP_EXPRESSION: 
			LisztClient_liszt()->watchPoints()[row]->setExp(str);
			break;
		default:
			assert(!"watchpoint table unknown column");
	}
}
- (IBAction) addEntry: (id) object {
	std::stringstream ss;
	ss << "Watchpoint " << LisztClient_liszt()->watchPoints().size();
	LisztClient_liszt()->addWatchPoint(ss.str(),"");
	[table reloadData];
	int row = LisztClient_liszt()->watchPoints().size() - 1;
	[table selectRow: row byExtendingSelection:NO];
	[table editColumn:WP_EXPRESSION row: row withEvent:nil select: YES];
}
- (IBAction) removeEntry: (id) object {
	int row = [table selectedRow];
	if(row >= 0) {
		//if we don't do this it tries to update a delete row
		[table deselectRow: row];
		LisztClient_liszt()->removeWatchPoint(row);
		[table reloadData];
	}
}
- (void) awakeFromNib {
}
@end
